/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 *
 * Potions from Sarien, (C) 1999-2001 Stuart George and Claudio Matsuoka
 */



#include <stdio.h>

#include "general.h"
#include "object.h"
#include "status.h"
#include "graphics.h"

boolean pos_legal(view_obj *o)
{
	int i = 0;
	UINT8 *p;
	
	p = backpribuffer;
	
	/* obvious ones */
	if((o->flags & VO_HORIZON) && (o->y <= status.horizon)) return false;
	if((o->flags & VO_HORIZON) && ((o->y - o->height + 1) < 0)) return false;
	if(o->x <= 0) return false;
	if(o->x + o->width > 160) return false;
	if(o->y > 167) return false;
	
	/* Priority screen checks */
	for(i = 0; i < o->width; i++) {
		if(pixel(p, ((o->x + i) * 2), o->y) == 0) return false;
		if((o->flags & VO_BLOCK) &&
		   (pixel(p, ((o->x + i) * 2), o->y) == 1)) return false;
		if((o->flags & VO_NOWATER) &&
		   (pixel(p, ((o->x + i) * 2), o->y) == 3)) return false;
		if((o->flags & VO_NOLAND) &&
		   (pixel(p, ((o->x + i) * 2), o->y) != 3)) return false;
	}

	return true;
}


/* Most of this stolen from Sarien */
void check_fix_position(view_obj *o)
{
	int count, dir, tries;
	
	dir = 0;
	count = tries = 1;

	while (!pos_legal(o)) { /* || check_clutter(v) || !check_priority(v)) {*/

		/* This added by me, fixes some stuff in SQ */
		if((o->flags & VO_HORIZON) && (o->y < status.horizon)) {
			o->y = status.horizon + 1;
			continue;
		}
		
		switch (dir) {
			case 0:			
				o->x--;
				if (--count) continue;
				dir = 1;
				break;
			case 1:			
				o->y++;
				if (--count) continue;
				dir = 2;
				tries++;
				break;
			case 2:			
				o->x++;
				if (--count) continue;
				dir = 3;
				break;
			case 3:			
				o->y--;
				if (--count) continue;
				dir = 0;
				tries++;
				break;
		}
		count = tries;
	}
}
