/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "general.h"
#include "gameid.h"
#include "resource.h"

struct gameid_s knowngames[] = {
	/* Sierra Games */
	{0x002B6E75, "Space Quest (1.1A)"	, "sq"	, "2.272"},
	{0x002BDA13, "Space Quest (2.2)"	, "sq"	, "2.917"},
	{0x00458DB6, "Space Quest 2 (2.0F)"	, "sq2"	, "2.936"},

	{0x004EB642, "Police Quest (2.0G)"	, "pq"	, "2.917"},
	
	{0x0032B3D8, "King's Quest (2.0F)"	, "kq"	, "2.917"},
	{0x0037C178, "King's Quest 2 (2.2)"	, "kq2"	, "2.917"},
	{0x0066740F, "King's Quest 3 (1.01)"	, "kq3"	, "2.272"},
	{0x0066CB1F, "King's Quest 3 (2.14)"	, "kq3"	, "2.936"},
	{0x009BAD22, "King's Quest 4 (2.0)"	, "kq4"	, "3.002.086"},
	{0x00546D55, "King's Quest 4 (2.3)"	, "kq4"	, "3.002.086"},
	
	{0x00540DD2, "Leisure suit Larry(1.00)"	, "ll"	, "2.440"},
	
	{0x0029496F, "Gold Rush! (2.01)"	, "gr"	, "3.002.149"},
	
	{0x00C2A6E1, "Manhunter NY (1.22)"	, "mh"	, "3.002.102"},
	{0x00CB8696, "Manhunter SF (3.02)"	, "mh2"	, "3.002.149"},
	
	{0x0025C450, "Black Cauldron (2.00)"	, "bc"	, "2.439"},
	{0x00CF3A00, "Donald Duck's Playground"	, ""	, "2.272"},
	{0x0029FA4A, "Mixed-up Mother Goose"	, "mg"	, "2.915"},
	
	/* Fan made games */
	{0x02B5E328, "V (0.10 beta)"		, "V"	, "3.002.149"},
	{0x04C009E0, "SQ: The Lost Chapter"	, ""	, "2.917"},
	
	/* Add other games here */
	
	{0x00000000, "Unknown game"		, ""	, "2.917"}
};

char agi3prefix[][5] = {"kq4", "gr", "mh", "mh2", "V", ""};  /* any others? */

struct gameid_s * id = NULL;


void id_game(void) {
	FILE *vol0;
	char filename[50];
	int i;
	UINT8 tmp = 0;
	UINT32 tmp_crc = 0;
	int knowngamescount;
	
	snprintf(filename, 49, "%svol.0", gamedir);
	vol0 = fopen(filename, "rb");

	for(i = 0; !vol0; i++) {
		if(agi3prefix[i][0] == 0) {
			printf("gameid: FATAL: failed to open *vol.0\n");
			exit(-1);
		}
		snprintf(filename, 49, "%s%svol.0", gamedir, agi3prefix[i]);
		vol0 = fopen(filename, "rb");
	}
	
	while(!feof(vol0)) {
		fread(&tmp, 1, 1, vol0);
		tmp_crc += tmp;
	}
	
	fclose(vol0);
	
	knowngamescount = sizeof(knowngames) / sizeof(struct gameid_s);
	for(tmp = 0; tmp < knowngamescount; tmp++)
		if(tmp_crc == knowngames[tmp].crc) id = &knowngames[tmp];

	if(!id) {
		id = &knowngames[tmp - 1];
		id->crc = tmp_crc;
		i--;
		if(i != -1) {
			strcpy(id->id, agi3prefix[i]);
			strcpy(id->agiver, "3.002.149");
		}
	}
	
	printf("gameid: CRC:0x%08X\n", (int)id->crc);
	printf("\tName: \"%s\"\n", id->name);
	printf("\tID: \"%s\"\n", id->id);
	printf("\tAGI version: %s\n", id->agiver);
}

