/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 */

#ifndef __EVENT_H__
#define __EVENT_H__

#include "general.h"

#define AGIL_KEY_ESCAPE			1

#define AGIL_KEY_1			2
#define AGIL_KEY_2			3
#define AGIL_KEY_3			4
#define AGIL_KEY_4			5
#define AGIL_KEY_5			6
#define AGIL_KEY_6			7
#define AGIL_KEY_7			8
#define AGIL_KEY_8			9
#define AGIL_KEY_9			10
#define AGIL_KEY_0			11

#define AGIL_KEY_MINUS			12
#define AGIL_KEY_EQUAL			13

#define AGIL_KEY_BACKSPACE		14
#define AGIL_KEY_TAB			15

#define AGIL_KEY_Q			16
#define AGIL_KEY_W			17
#define AGIL_KEY_E			18
#define AGIL_KEY_R			19
#define AGIL_KEY_T			20
#define AGIL_KEY_Y			21
#define AGIL_KEY_U			22
#define AGIL_KEY_I			23
#define AGIL_KEY_O			24
#define AGIL_KEY_P			25
#define AGIL_KEY_BRACKET_LEFT		26
#define AGIL_KEY_BRACKET_RIGHT		27

#define AGIL_KEY_ENTER			28

#define AGIL_KEY_CONTROL		29

#define AGIL_KEY_A			30
#define AGIL_KEY_S			31
#define AGIL_KEY_D			32
#define AGIL_KEY_F			33
#define AGIL_KEY_G			34
#define AGIL_KEY_H			35
#define AGIL_KEY_J			36
#define AGIL_KEY_K			37
#define AGIL_KEY_L			38
#define AGIL_KEY_SEMICOLON		39
#define AGIL_KEY_APOSTROPHE		40
#define AGIL_KEY_GRAVE			41

#define AGIL_KEY_LEFTSHIFT		42
#define AGIL_KEY_BACKSLASH		43

#define AGIL_KEY_Z			44
#define AGIL_KEY_X			45
#define AGIL_KEY_C			46
#define AGIL_KEY_V			47
#define AGIL_KEY_B			48
#define AGIL_KEY_N			49
#define AGIL_KEY_M			50
#define AGIL_KEY_COMMA			51
#define AGIL_KEY_PERIOD			52
#define AGIL_KEY_SLASH			53

#define AGIL_KEY_RIGHTSHIFT		54
#define AGIL_KEY_KEYPADMULTIPLY		55

#define AGIL_KEY_ALT			56
#define AGIL_KEY_SPACE			57
#define AGIL_KEY_CAPSLOCK		58

#define AGIL_KEY_F1			59
#define AGIL_KEY_F2			60
#define AGIL_KEY_F3			61
#define AGIL_KEY_F4			62
#define AGIL_KEY_F5			63
#define AGIL_KEY_F6			64
#define AGIL_KEY_F7			65
#define AGIL_KEY_F8			66
#define AGIL_KEY_F9			67
#define AGIL_KEY_F10			68

#define AGIL_KEY_NUMLOCK		69
#define AGIL_KEY_SCROLLLOCK		70

#define AGIL_KEY_KEYPAD7		71
#define AGIL_KEY_CURSORUPLEFT		71
#define AGIL_KEY_KEYPAD8		72
#define AGIL_KEY_CURSORUP		72
#define AGIL_KEY_KEYPAD9		73
#define AGIL_KEY_CURSORUPRIGHT		73
#define AGIL_KEY_KEYPADMINUS		74
#define AGIL_KEY_KEYPAD4		75
#define AGIL_KEY_CURSORLEFT		75
#define AGIL_KEY_KEYPAD5		76
#define AGIL_KEY_KEYPAD6		77
#define AGIL_KEY_CURSORRIGHT		77
#define AGIL_KEY_KEYPADPLUS		78
#define AGIL_KEY_KEYPAD1		79
#define AGIL_KEY_CURSORDOWNLEFT	79
#define AGIL_KEY_KEYPAD2		80
#define AGIL_KEY_CURSORDOWN		80
#define AGIL_KEY_KEYPAD3		81
#define AGIL_KEY_CURSORDOWNRIGHT	81
#define AGIL_KEY_KEYPAD0		82
#define AGIL_KEY_KEYPADPERIOD		83

/* These appear to be new (since XT), but I don't have my book on me */
#define AGIL_KEY_LESS			86
#define AGIL_KEY_F11			87
#define AGIL_KEY_F12			88
#define AGIL_KEY_KEYPADDIVIDE		98
#define AGIL_KEY_PRINTSCREEN		99
#define AGIL_KEY_BREAK			101


extern UINT8 keytable[];
extern boolean event_catchkeys;
extern int event_caughtkey;

void event_init(void);

void event_flushqueue(void);
void event_add(UINT8 code);
boolean event_check(UINT8 code);
void event_flushkeys(void);
void event_addkey(int scancode, UINT8 eventcode);
boolean event_checkkey(int scancode);
boolean event_checkkey_noexec(int scancode);

int event_waitforkey(void);

void event_kb_handler(int scancode, int press);

#endif
