/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 */

#ifndef __GRAPHICS_H__
#define __GRAPHICS_H__

#include "general.h"

#define pixel(buf,x,y)	\
	buf[(y * 320) + x]

#define pset(x,y)	\
	psetv(x, y);	\
	psetp(x, y);

/* the various screen buffers */			
extern UINT8 *video_buffer;

extern UINT8 *backvisbuffer;
extern UINT8 *backpribuffer;
extern UINT8 *workvisbuffer;
extern UINT8 *workpribuffer;
extern UINT8 *textmodebuffer;

/* initialization functions */
int graph_malloc_screens(void);
void graph_free_screens(void);
void graph_loadfont(void);

/* picture drawing primatives */
extern boolean pripen;
extern boolean vispen;
extern UINT8 pricolor;
extern UINT8 viscolor;
void psetp(int x, int y);
void psetv(int x, int y);
UINT8 pgetp(int x, int y);
UINT8 pgetv(int x, int y);
void line(int x1, int y1, int x2, int y2);
void fillv(int x, int y);
void fillp(int x, int y);

/* more complex graphic functions */
void graph_drawbox(UINT8 * buffer, int x, int y, int w, int h, UINT8 bg, UINT8 border);
void graph_drawchar(UINT8 * buffer, int x, int y, char ch, UINT8 fg, SINT8 bg);
void graph_drawstring(UINT8 * buffer, int x, int y, char * str, UINT8 fg, SINT8 bg);
/*void graph_messagebox(char * message, int x, int y, int w);*/
/* Moved to message.h */

UINT8 graph_get_real_pri(int x, int y);

#endif
