/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 */

#ifndef __OBJECT_H__
#define __OBJECT_H__

#include "general.h"

/* for view_obj.flags */
#define VO_ANIMATE	(1 << 0)
#define VO_FIX_LOOP	(1 << 1)
#define VO_FIX_PRI	(1 << 2)
#define VO_DRAWN	(1 << 3)
#define VO_CYCLE	(1 << 4)
#define VO_REVERSE	(1 << 5)
#define VO_HORIZON	(1 << 6)
#define VO_BLOCK	(1 << 7)
#define VO_OBJECTS	(1 << 8)
#define VO_MOTION	(1 << 9)
#define VO_AUTO_MOVE	(1 << 10)
#define VO_FOLLOW_EGO	(1 << 11)
#define VO_WANDER	(1 << 12)
#define VO_NOLAND	(1 << 13)
#define VO_NOWATER	(1 << 14)
#define VO_UPDATE	(1 << 15)

#define VO_NOT_MOVED	(1 << 16)
#define VO_ON_SCREEN	(1 << 17)

typedef struct view_object_s {
	UINT8 x, y;
	UINT8 tx, ty;
	UINT8 view, loop, cel;
	UINT8 priority;
	UINT8 cycle_time, cycle_count;
	UINT8 step_size, step_time, step_count;
	UINT8 direction;
	UINT8 target_flag;
	UINT8 do_once_flag;

	UINT8 steps;
	
	UINT16 loop_ofs, cel_ofs;
	UINT8 noloops, nocels;
	UINT8 width, height;
	UINT8 trans;
	boolean mirror;

	UINT8 oldx, oldy, oldw, oldh;
		
	UINT32 flags;	/* Bitfield */
} view_obj;

extern view_obj object[255];

void object_setdefaultpri(view_obj *o);
void object_setdefaultloop(view_obj *o);

void object_update(view_obj *o);

#endif
