/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 */

#ifndef __RESOURCE_H__
#define __RESOURCE_H__

#include "general.h"

typedef struct resource_s {
	enum {
		logic,
		picture,
		view,
		sound
	} resource_type;
	
	UINT8 id;
	
	UINT8 vol;
	UINT32 offset;

	UINT16 size;
		
	UINT8 * data;

	/* logic specific */
	char ** message;
	UINT16 ssIP;
	boolean compressed;
	
} resource_t;


typedef struct inv_item_s {
	UINT8 room;
	char name[25];
} inv_item_t;

extern inv_item_t inv_item[];

extern resource_t *LOGIC[];
extern resource_t *PICTURE[];
extern resource_t *VIEW[];
extern resource_t *SOUND[];

extern char gamedir[];

int res_init(void);

void res_load(resource_t *res);
void res_unload(resource_t *res);

void res_shutdown(void);
void res_load_words(void);
void res_load_objects(void);

#endif
