/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 */

#include <string.h>

#include "general.h"
#include "graphics.h"
#include "message.h"

struct mbox_s {
	boolean onscreen;
	int width, height;
	int x, y;
/*	UINT8 * visdata;
	UINT8 * pridata;*/
} mbox;


void message_mbox(char * message, int x, int y, int w)
{
	int numlines = 0;
	char line[20][39];
	int inpos = 0, outpos = 0;
	int maxlength = 0;
	int width, height;
	int i;
	
	if(w > (37 - (x / 8))) w = 0;
	if(w <= 0) w = 37 - (x / 8);	/* automatic line length */
	
	/* divide input string into lines */
	for(inpos = 0; message[inpos] != 0; inpos++) { 
		if(outpos >= w) { /* line length exceeded */
			do {
				/* trace back to last space */
				outpos--; 
				inpos--;
			} while(line[numlines][outpos] != 32);
			/* start new line */
			line[numlines][outpos] = 0;
			if(outpos > maxlength) maxlength = outpos;
			numlines++;
			outpos = 0;
			continue;
		}
		if(message[inpos] == '\n') { /* explicit new line */
			line[numlines][outpos] = 0;
			if(outpos > maxlength) maxlength = outpos;
			outpos = 0;
			numlines++;
			continue;
		}
		line[numlines][outpos] = message[inpos];
		outpos++;
	}
	line[numlines][outpos] = 0;
	if(outpos > maxlength) maxlength = outpos;
	
	/* calculate dimentions */
	width = (maxlength * 8) + 18;
	height = ((numlines + 1) * 8) + 10;
	if(x <= 0) x = 160 - (width / 2);
	if(y <= 0) y = 88 - (height / 2);
	
	mbox.x = x;
	mbox.y = y;
	mbox.width = width;
	mbox.height = height;
	mbox.onscreen = true;
		
	/* draw message box */
	graph_drawbox(video_buffer, x, y, width, height, 15, 4);
	/* draw box in pri screen */
	for(i = 0; i < height; i++) {
		memset(workpribuffer + (320 * (y + i) + x), 16, width);
	}
	
	for(i = 0; i <= numlines; i++) {
		graph_drawstring(video_buffer, x + 10, y + (i * 8) + 5, line[i], 0, 15);
	}
}


void message_erasebox(void)
{
	UINT8 * p;
	UINT8 * v;
	UINT16 o = 0;
	int i;
	
	p = backpribuffer - 2560;
	v = backvisbuffer - 2560;

	if(!mbox.onscreen) return;
		
	for(i = 0; i < mbox.height; i++) {
		o = (320 * (mbox.y + i) + mbox.x);
		memcpy(workpribuffer + o, p + o, mbox.width);
		memcpy(workvisbuffer + o, v + o, mbox.width);
	}
	
	mbox.onscreen = false;
}
