/*
 * AGIL: Adventure Game Interpreter for Linux, (C) 2001, 2002 RaDIaT1oN
 * 	See the file COPYING
 *
 * Portion by Copyright (C) 1997 Lance Ewing
 */

#include <stdio.h>
#include <string.h>

#include "general.h"
#include "picture.h"
#include "graphics.h"
#include "resource.h"
#include "pic_op.h"
#include "message.h"


/* for comressed AGI3 PICTURE resources */
/* from AGI spec: by Lance Ewing. */
void pic_inflate(UINT8 * dest, FILE * stream, int size)
{
	boolean alt = 0;
	int data, olddata = 0, outdata;
	
	do {
		data = fgetc(stream); size--;

		if(alt)	
			outdata = ((olddata & 0x0F) << 4) | ((data & 0xF0) >> 4);
		else
			outdata = data;
		
		*dest = outdata; dest++;
		if((outdata == 0xF0) || (outdata == 0xF2)) {
			if(alt) {
				*dest = (data & 0x0F); dest++;
				alt = false;
			} else {
				data = fgetc(stream); size--;
				*dest = (data >> 4); dest++;
				alt = true;
			}
		} 
		olddata = data;

	} while ((outdata != 0xFF) && (size != 0));
}


/* Draw picture to backvisbuffer and backpribuffer */
void pic_draw(resource_t * pic_res, boolean clear) 
{
	UINT8 * p;
	UINT16 (*drawopcode[])(UINT8 *) = { /* see pic_opcodes.[hc] */
		enablevisdraw, 		/*F0*/
		disablevisdraw,		/*F1*/
		enablepridraw, 		/*F2*/
		disablepridraw, 	/*F3*/
		drawcorner,		/*F3*/
		drawcorner, 		/*F5*/
		drawabsline,		/*F6*/
		drawrelativeline,	/*F7*/
		floodfill,		/*F8*/
		setbrushstyle, 		/*F9*/
		plotBrush, 		/*FA*/
		NULL,			/*FB*/
		NULL,			/*FC*/
		NULL,			/*FD*/
		NULL			/*FE*/
	};

	UINT16 index = 0;
	p = pic_res->data;

	if(!p) return;	

	pripen = false;
	vispen = false;
	pricolor = 4;
	viscolor = 15;
	patCode = 0;

	message_erasebox();
	
	if(clear) {
		memset(backpribuffer, 0x04, 320 * 168); /* red */
		memset(backvisbuffer, 0x0F, 320 * 168);	/* white */
	}

	while((p[index] != 0xFF) && (index < pic_res->size)) {
		if((p[index] >= 0xF0) && drawopcode[p[index] - 0xF0]) {
			index += drawopcode[p[index] - 0xF0](&p[index]);
		} else {
#ifndef DJGPP
			printf("picture: WARNING: Unrecognised command : %.2X\n", p[index]);
#endif
			index++;
		}
	}
}




